/****************************************************************************
Clase PCX

Version 1.2 - 16 Nov 1999
- Se crea la funcion leer_cabecera() para leer solo una vez la
  cabecera del pcx
- Se modifica la funcion Dibujar para dibujar sin leer la paleta
  solo leyendo el bitmap

Programado por:
JOSE LUIS DE LA CRUZ LAZARO 
ramondc@hotmail.com
Pagina Web: http://www.geocities.com/joseluisdl/jldl.htm
****************************************************************************/

#ifndef __PCXBGI_H
#define __PCXBGI_H


#include <stdio.h>
#include <dos.h>

#ifndef __GRAPHICS_H
#include <graphics.h>
#endif

class PCX
{
 public:
		PCX(); // constructor
		~PCX(); // destructor
		//Array que contendr la paleta de colores del PCX
		unsigned char paleta[256][3];
		//int tamano_paleta;
		//orden: contiene el orden en que la paleta del pcx
		//       se aadira a la paleta de la vga.
		int orden;
		int ancho;
		int alto;
 private:
		int bytes_por_linea;
		FILE *fp;
 public:
		void Dibujar(int x,int y);
		void leer_cabecera(int _orden,char *nombre);
 private:
		void Paleta(void);
		void CorrerPaleta(void);


};

PCX::PCX()
{
 alto=0;
 ancho=0;
 orden=0;
 bytes_por_linea=0;
 //fp=new FILE;
}

PCX::~PCX()
{
  fclose(fp);   // Cerramos el fichero pcx
  //delete fp;
}

void PCX::Paleta(void)
{
 unsigned char cont1;
 int cont;

 cont=0;
 cont1=0;
 // El cdigo que sigue a continuacin pasa el contenido del array
 //	"Paleta" a la paleta de la VGA
 for(cont=0;cont<256;cont++)
 {
  outportb(0x03c8,cont+orden*256+16);
  for(cont1=0;cont1<3;cont1++)
   outportb(0x03c9,paleta[cont][cont1]);
 }
}

void PCX::CorrerPaleta( void)
{
 unsigned char cont1;
 int cont;

 for(cont=0;cont<256;cont++)
  for(cont1=0;cont1<3;cont1++)
   paleta[cont][cont1]=(paleta[cont][cont1]>>2);
   //Movemos 2 bits
   //hacia la derecha todos los bytes ledos en la paleta del PCX.
   //Los componentes RGB de la paleta se encuentran en los 6 bits
   //de mayor peso de los valores ledos del fichero
}

void PCX::leer_cabecera(int _orden,char *nombre)
{
 if(nombre==NULL)
  return;
 if((fp=fopen(nombre,"rb"))==NULL)
  return;

 orden=_orden;
 fseek(fp,-768L,SEEK_END);  // Nos situamos en el comienzo de la paleta
 fread(paleta,768,1,fp);    // Leemos los bytes componentes del RGB
 CorrerPaleta();
 Paleta();

 //Leemos sus dimensiones
 fseek(fp,8L,SEEK_SET);
 fread(&ancho,2,1,fp);
 fread(&alto,2,1,fp);
 ancho++;
 alto++;

 fseek (fp,66L,SEEK_SET);
 fread(&bytes_por_linea,2,1,fp);
}


// Dibuja el grafico directamnete mientras lo lee, en la posicion (x,y)
void PCX::Dibujar(int x,int y)
{
 if(fp==NULL)
  return;

 fseek (fp,128L,SEEK_SET); // Nos saltamos la cabecera del PCX

 setviewport(x,y,x+ancho,y+alto,1);

 int i,j;
 unsigned char num_bytes,data;

 for(j=0;j<alto;j++)
  for(i=0;i<bytes_por_linea;)
  {
   data=fgetc(fp); //Leemos el bitmap byte por byte
   if(i<ancho)
   {
	if(data>=192) // es un Rle ?
	{
	 num_bytes=data-192; // Cuantos veces se repite el color ?
	 data=fgetc(fp);     // Leemos el color que se repite
	 while(num_bytes-- > 0)
	  putpixel(i++,j,data+orden*256+16);
	}
	else  //si no hay repeticion de color
	 putpixel(i++,j,data+orden*256+16);
   }else
	 i++;
  }
  //se vuelve al puerto por defecto
  setviewport(0,0,getmaxx(),getmaxy(),1);
}

#endif